# Introduction

Code in this directory (`biobricks_data_summary`) summarizes the the BioBrick description (in the `biobricks-downloads/res` directory) using the LLM model Llama2. Concise description of proteins is generated by the LLM for training in the BERT model.

# Programming Guide

## Environment Configuration

`pip install llama-cpp-python=0.1.78 `

## Model downloading

Llama models are available on [huggingface.co](https://huggingface.co/models?sort=trending&search=thebloke%2Fllama-2). Search `thebloke/llama-2`, and download a version of the model you need. For example:

[TheBloke/Llama-2-7B-Chat-GGML at main (huggingface.co)](https://huggingface.co/TheBloke/Llama-2-7B-Chat-GGML/tree/main): Download llama-2-7b-chat.ggmlv3.q5_1.bin，4.7G

[TheBloke/Llama-2-13B-chat-GGML at main (huggingface.co)](https://huggingface.co/TheBloke/Llama-2-13B-chat-GGML/tree/main): Download llama-2-13b-chat.ggmlv3.q5_1.bin，9G

[TheBloke/Llama-2-70B-GGUF at main (huggingface.co)](https://huggingface.co/TheBloke/Llama-2-70B-GGUF/tree/main): Download llama-2-70b.Q3_K_S.gguf，27G

The downloaded models will be stored in the `biobricks_data_summary/llm_models/` directory.

## Hardware Requirements

It takes certain hardware resources for LLMs to run successfully. For example, llama-2-7b-chat.ggmlv3.q5_1.bin takes up 10+ GB of GPU memory, and llama-2-13b-chat.ggmlv3.q5_1.bin requires even more. So make sure your GPU has enough memory when running the LLM model.

## Run Model

Check the paths in the `get_data.py` and start running or debugging.

`python get_data.py`

# 其他

iGEM_BioBrick-Summary.ipynb is the first version of code. Its function is similar to `get_data.py`
