
import numpy as np
import torch
# torch.set_printoptions(threshold=np.inf)

from mono.model.bert import CNBertReverseDict
from transformers import BertTokenizer, BertConfig
import re
import sys
sys.path.append('../')

word2bpes=np.load("./npy/cn_word2bpes.npy").tolist()
# target_words=np.load("./cn_target_words.npy").tolist()
target_words=np.load("./npy/cn_target_words.npy")

#** 加载预训练模型
# model_config = BertConfig.from_pretrained('pretrained_models/hfl--chinese-bert-wwm/config.json')
# 修改配置
# model_config.output_hidden_states = True #* 此参数在config文件中没有
# model_config.output_attentions = True

print( '开始加载模型: ' )
model = CNBertReverseDict( word2bpes=word2bpes, pad_id=0, number_word_in_train=53978) 
# model = CNBertReverseDict( word2bpes=word2bpes, pad_id=0, number_word_in_train=53978) 

states = torch.load('save_models/cn-rd-t1.bin').state_dict()
model.load_state_dict(states)
# print(model)

model.eval() #??**
if torch.cuda.is_available():
	model.cuda(0)
print( '模型加载完毕; ' )

# input: 用户输入的str
def input_to_bpe( input_str ):
	max_word_len = 4
	tokenizer = BertTokenizer.from_pretrained('pretrained_models/hfl--chinese-bert-wwm' ) #** 
	# tokenizer.do_basic_tokenize = True
	mask_id, sep_id, cls_id, pad_id, unk_id = 103, 102, 101, 0, 100

	out_bpe = []
	for word in input_str.split(): # 用空格拆分成一个个的词, 然后遍历
		out_bpe.extend(tokenizer.tokenize(word)) # 将分词后的 BPE 编码序列逐一添加到 definition 列表中。
	out_bpe = tokenizer.convert_tokens_to_ids(out_bpe)

	output = [cls_id] + [mask_id] * max_word_len  + [sep_id] + out_bpe
	output = output[:256]
	output.append(sep_id)

	# return out_bpe
	return output



# word1 = '当前的社会'
# word1 = '很多人说同样的话'
# bpe1 = input_to_bpe( word1 )
# with torch.no_grad():
# 	res_dict = model( bpe1 )
# # res_dict = model.forward( bpe1 )
# res = res_dict['pred'].cpu().numpy().tolist()[0]
# print( res[:10] )


print( '开始推理,请输入: ' )

try:
	while True:
		word = input()
		print( '您的输入为: ', word )
		bpe = input_to_bpe( word )
		tensor_bpe = torch.tensor( [bpe] ).cuda(0)
		with torch.no_grad():
			res_dict = model( tensor_bpe )
			# res_dict = model.forward( tensor_bpe )
		
		# 若写 res_dict = model( bpe ) 或res_dict = model.forward( bpe ) #* 无法运行
		
		# res = res_dict['pred'].cpu().numpy().tolist()[0]
		res = res_dict['pred'].cpu().numpy()[0]

		top_num = res.argsort()[ -15 : ][::-1] #* 获取numpy数组中的N个最大值的索引(从大往小排列)
		# top_n = np.array(res).argsort()[-10:][::-1]
		print( res[top_num] )
		print( top_num )

		print( target_words[top_num] )

except:
	pass
